from resources.lib.plugins.summary import Summary
from ..plugin import Plugin
import xbmcgui
import base64
import json
import requests, os

import urllib.parse
try:
    from resources.lib.util.common import *
except ImportError:
    from .resources.lib.util.common import *

import xbmcaddon
addon_id = xbmcaddon.Addon().getAddonInfo('id')
default_icon = xbmcaddon.Addon(addon_id).getAddonInfo('icon')
default_fanart = xbmcaddon.Addon(addon_id).getAddonInfo('fanart')

import xbmcaddon
from xbmcvfs import translatePath

addon = xbmcaddon.Addon()

USER_DATA_DIR = translatePath(addon.getAddonInfo("profile"))
ADDON_DATA_DIR = translatePath(addon.getAddonInfo("path"))
RESOURCES_DIR = os.path.join(ADDON_DATA_DIR, "resources", "lib", "data")

from os.path import join
from resources.lib.util import dbase as do_data
DB = do_data.Database()
my_db = os.path.join(RESOURCES_DIR, "loop_cache.db")
my_table  = 'art' 

class default_process_item(Plugin):
    name = "default process item"
    priority = 0

    def process_item(self, item):
        do_log(f'{self.name} - Item = \n {str(item)} ' )  
        is_dir = False
        tag = item["type"]
        link = item.get("link", "")
        summary = item.get("summary")
        if summary:
            del item["summary"]
        if link:
            if tag == "dir":
                link = f"/get_list/{link}"
                is_dir = True
                
            if tag == "plugin":   
                plug_item = urllib.parse.quote_plus(str(link))  
                if 'youtube' in plug_item:
                    link = f"/get_list/{link}"
                    is_dir = True
                else :
                    link = f"/run_plug/{plug_item}"                 
                    is_dir = False
                
        if tag == "item":
            link_item = base64.urlsafe_b64encode(bytes(json.dumps(item), 'utf-8')).decode("utf-8")
            
            if str(link).lower() == 'settings' :
                link = f"settings/{link}"        
            
            elif str(link).lower().startswith("message/") :   
                link = f"show_message/{link}" 
                               
            else :     
                link = f"play_video/{link_item}"
                        
        # thumbnail = item.get("thumbnail", "")
        # fanart = item.get("fanart", "")
        thumbnail = default_icon
        fanart = default_fanart    
                    
        my_id = item.get("id", "empty")
        
        if my_id == "empty" :                         
            thumbnail = item.get("thumbnail", default_icon)
            fanart = item.get("fanart", default_fanart)                                       
        else :      
            check_data = DB.search_db(my_db, my_table, int(my_id)) 
            # do_log(f'{self.name} - data returned = \n {str(check_data)} ' )  
            if not check_data :
                my_thumb = thumbnail
                my_art = fanart
            else :
                my_thumb = base64.b64decode(check_data[-2][::-1]).decode()
                my_art = base64.b64decode(check_data[-1][::-1]).decode()                
            if my_thumb.startswith('http') : thumbnail = my_thumb
            else : thumbnail = default_icon
            if my_art.startswith('http') : fanart = my_art   
            else : fanart = default_fanart       
                                                                                        
        list_item = xbmcgui.ListItem(
            item.get("title", item.get("name", "")), offscreen=True
        )
        list_item.setArt({"thumb": thumbnail, "fanart": fanart})
        item["list_item"] = list_item
        item["link"] = link
        item["is_dir"] = is_dir
        if summary:
            item["summary"] = summary
        return item
